#asm
    .equ __lcd_port=0x15
#endasm 
eeprom long int pass_store= 123456,master_password= 291279;
// CodeVisionAVR C Compiler
// (C) 1998-2003 Pavel Haiduc, HP InfoTech S.R.L.

// I/O registers definitions for the ATmega8535(L)


#pragma used+
sfrb TWBR=0;
sfrb TWSR=1;
sfrb TWAR=2;
sfrb TWDR=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      // 16 bit access
sfrb ADCSRA=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   // 16 bit access
sfrb UBRRH=0x20;
sfrb UCSRC=0X20;
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  // 16 bit access
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  // 16 bit access
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  // 16 bit access
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb SFIOR=0x30;
sfrb OSCCAL=0x31;
sfrb OCDR=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TWCR=0x36;
sfrb SPMCR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GICR=0x3b;
sfrb OCR0=0X3c;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

// Interrupt vectors definitions


// Needed by the power management functions (sleep.h)
#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#endasm


/* LCD driver routines

  CodeVisionAVR C Compiler
  (C) 1998-2003 Pavel Haiduc, HP InfoTech S.R.L.

  BEFORE #include -ING THIS FILE YOU
  MUST DECLARE THE I/O ADDRESS OF THE
  DATA REGISTER OF THE PORT AT WHICH
  THE LCD IS CONNECTED!

  EXAMPLE FOR PORTB:

    #asm
        .equ __lcd_port=0x18
    #endasm
    #include <lcd.h>

*/


#pragma used+

void _lcd_ready(void);
void _lcd_write_data(unsigned char data);
// write a byte to the LCD character generator or display RAM
void lcd_write_byte(unsigned char addr, unsigned char data);
// read a byte from the LCD character generator or display RAM
unsigned char lcd_read_byte(unsigned char addr);
// set the LCD display position  x=0..39 y=0..3
void lcd_gotoxy(unsigned char x, unsigned char y);
// clear the LCD
void lcd_clear(void);
void lcd_putchar(char c);
// write the string str located in SRAM to the LCD
void lcd_puts(char *str);
// write the string str located in FLASH to the LCD
void lcd_putsf(char flash *str);
// initialize the LCD controller
unsigned char lcd_init(unsigned char lcd_columns);

#pragma used-
#pragma library lcd.lib


// CodeVisionAVR C Compiler
// (C) 1998-2006 Pavel Haiduc, HP InfoTech S.R.L.

// Prototypes for standard I/O functions


// CodeVisionAVR C Compiler
// (C) 1998-2002 Pavel Haiduc, HP InfoTech S.R.L.

// Variable length argument list macros



typedef char *va_list;





#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);

char *gets(char *str,unsigned int len);

void printf(char flash *fmtstr,...);
void sprintf(char *str, char flash *fmtstr,...);
void snprintf(char *str, unsigned int size, char flash *fmtstr,...);
void vprintf (char flash * fmtstr, va_list argptr);
void vsprintf (char *str, char flash * fmtstr, va_list argptr);
void vsnprintf (char *str, unsigned int size, char flash * fmtstr, va_list argptr);
signed char scanf(char flash *fmtstr,...);
signed char sscanf(char *str, char flash *fmtstr,...);




                                   

            


#pragma used-

#pragma library stdio.lib


// CodeVisionAVR C Compiler
// (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.


#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

// this #pragma directive will prevent the compiler
// from generating a warning that the function was
// declared, but not used in the program
#pragma used+
#pragma used+

// library function prototypes
void kbd_init();
int kbd_read();

#pragma used-

// this #pragma directive will tell the compiler to
// compile/link the functions from the kbd.lib library
#pragma library kbd.lib
 
int i,j,k,fail=0; 
long int id_value, pass_value, pass[6]; 
bit match=0;
void password()
{i=0;
do{
        delay_ms(50);
        while(!kbd_read()){}
        j=kbd_read();
        if(j<11)
        {if(j==10) j=0; pass[i]=j;
        lcd_gotoxy(5+i,1); 
        lcd_putsf("*"); i++;}
} while(i<6);   
delay_ms(100);
pass_value=pass[5]+ 10*pass[4]+ 100*pass[3]+ 1000*pass[2]+ 10000*pass[1]+ 100000*pass[0];
}
void pass_change()
{
lcd_clear(); lcd_gotoxy(0,0); 
lcd_putsf("Enter New "); 
lcd_gotoxy(0,1); 
lcd_putsf("Password:"); 
delay_ms(50); k=0;
do{
delay_ms(50);
while(!kbd_read()){}
j=kbd_read();
if(j<11)
{if(j==10) j=0; 
pass[k]=j; 
k++; 
lcd_gotoxy(9+k,1); 
lcd_putsf("*");}
} while(k<6);
pass_value=pass[5]+ 10*pass[4]+ 100*pass[3]+ 1000*pass[2]+ 10000*pass[1]+ 100000*pass[0];
pass_store=pass_value;
id_value=pass_store;  
delay_ms(100);
if(pass_value==id_value){lcd_clear();
lcd_putsf("Password changed");}
else {lcd_clear(); 
lcd_putsf("Verify failed");} 
delay_ms(300);}
void unlock()
{
PORTA.0=~PORTA.0;lcd_clear();
lcd_gotoxy(1,0);
lcd_putsf("Door Unlocked"); 
lcd_gotoxy(2,1);
lcd_putsf("Please enter");
delay_ms(300); 
for(k=0;k<20;k++)
{lcd_clear();
delay_ms(50);
lcd_gotoxy(1,0);
lcd_putsf("Door Unlocked"); 
lcd_gotoxy(2,1);
lcd_putsf("Please enter"); 
delay_ms(50);} 
PORTA.0=~PORTA.0; return;
}
void main()
{ 
PORTA=0x00; 
DDRA=0xFF; 
kbd_init(); 
lcd_init(16);
lcd_clear(); 
lcd_gotoxy(4,0); 
lcd_putsf("Welcome!"); 
delay_ms(100); 
label1: lcd_clear(); 
lcd_gotoxy(1,0); 
lcd_putsf("Enter Password:"); 
delay_ms(50); 
password();
if(pass_value==pass_store){
match=1;
} 
else if(pass_value==master_password) {
match=1; 
pass_change(); 
match=0; 
fail=0; 
goto label1;
} 
else {match=0;
}   
if(match==1) 
{
match=0;
fail=0; 
delay_ms(100); 
unlock(); 
goto label1;
}
else 
{
lcd_clear();
 lcd_putsf("Invalid Password"); 
 match=0; 
 fail=fail+1; 
 delay_ms(200);
  if(fail==3)
  {
  lcd_clear(); 
  lcd_gotoxy(1,0);
  lcd_putsf("Contact System ");
  lcd_gotoxy(1,1);
  lcd_putsf("Administrator");
  }
   else 
   {
   goto label1;
   }
   }
}
